Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -781,34 +1036,33 @@
     NAMESPACE   => 'xmpTPg',
     TABLE_DESC => 'XMP Paged-Text',
-    NOTES => 'XMP Paged-Text schema tags.',
+    NOTES => 'XMP Paged-Text namespace tags.',
     MaxPageSize         => { Struct => \%sDimensions },
     NPages              => { Writable => 'integer' },
-    Fonts               => { Struct => \%sFont, List => 'Bag' },
-    FontsFontName       => { Flat => 1, Name => 'FontName' },
-    FontsFontFamily     => { Flat => 1, Name => 'FontFamily' },
-    FontsFontFace       => { Flat => 1, Name => 'FontFace' },
-    FontsFontType       => { Flat => 1, Name => 'FontType' },
-    FontsVersionString  => { Flat => 1, Name => 'FontVersion' },
-    FontsComposite      => { Flat => 1, Name => 'FontComposite' },
-    FontsFontFileName   => { Flat => 1, Name => 'FontFileName' },
-    FontsChildFontFiles => { Flat => 1, Name => 'ChildFontFiles' },
-    Colorants           => { Struct => \%sColorant, List => 'Seq' },
-    ColorantsSwatchName => { Flat => 1, Name => 'ColorantSwatchName' },
-    ColorantsMode       => { Flat => 1, Name => 'ColorantMode' },
-    ColorantsType       => { Flat => 1, Name => 'ColorantType' },
-    ColorantsCyan       => { Flat => 1, Name => 'ColorantCyan' },
-    ColorantsMagenta    => { Flat => 1, Name => 'ColorantMagenta' },
-    ColorantsYellow     => { Flat => 1, Name => 'ColorantYellow' },
-    ColorantsBlack      => { Flat => 1, Name => 'ColorantBlack' },
-    ColorantsRed        => { Flat => 1, Name => 'ColorantRed' },
-    ColorantsGreen      => { Flat => 1, Name => 'ColorantGreen' },
-    ColorantsBlue       => { Flat => 1, Name => 'ColorantBlue' },
-    ColorantsL          => { Flat => 1, Name => 'ColorantL' },
-    ColorantsA          => { Flat => 1, Name => 'ColorantA' },
-    ColorantsB          => { Flat => 1, Name => 'ColorantB' },
+    Fonts               => {
+        FlatName => '',
+        Struct => \%sFont,
+        List => 'Bag',
+    },
+    FontsVersionString  => { Name => 'FontVersion',     Flat => 1 },
+    FontsComposite      => { Name => 'FontComposite',   Flat => 1 },
+    Colorants           => {
+        FlatName => 'Colorant',
+        Struct => \%sColorant,
+        List => 'Seq',
+    },
     PlateNames          => { List => 'Seq' },
-);
-
-# PDF schema properties (pdf)
+    # the following found in an AI file:
+    HasVisibleTransparency => { Writable => 'boolean' },
+    HasVisibleOverprint    => { Writable => 'boolean' },
+    SwatchGroups => {
+        Struct => \%sSwatchGroup,
+        List => 'Seq',
+    },
+    SwatchGroupsColorants => { Name => 'SwatchGroupsColorants', Flat => 1 },
+    SwatchGroupsGroupName => { Name => 'SwatchGroupName',       Flat => 1 },
+    SwatchGroupsGroupType => { Name => 'SwatchGroupType',       Flat => 1 },
+);
+
+# PDF namespace properties (pdf)
 %Image::ExifTool::XMP::pdf = (
     %xmpTableDefaults,
@@ -817,5 +1071,5 @@
     TABLE_DESC => 'XMP PDF',
     NOTES => q{
-        Adobe PDF schema tags.  The official XMP specification defines only
+        Adobe PDF namespace tags.  The official XMP specification defines only
         Keywords, PDFVersion, Producer and Trapped.  The other tags are included
         because they have been observed in PDF files, but some are avoided when
@@ -836,10 +1090,10 @@
         PrintConv => { True => 'True', False => 'False', Unknown => 'Unknown' },
     },
-    Keywords    => { },
+    Keywords    => { Priority => -1 }, # (-1 to get below Priority 0 PDF:Keywords)
     PDFVersion  => { },
     Producer    => { Groups => { 2 => 'Author' } },
 );
 
-# PDF extension schema properties (pdfx)
+# PDF extension namespace properties (pdfx)
 %Image::ExifTool::XMP::pdfx = (
     %xmpTableDefaults,
@@ -853,5 +1107,5 @@
 );
 
-# Photoshop schema properties (photoshop)
+# Photoshop namespace properties (photoshop)
 %Image::ExifTool::XMP::photoshop = (
     %xmpTableDefaults,
@@ -859,5 +1113,5 @@
     NAMESPACE   => 'photoshop',
     TABLE_DESC => 'XMP Photoshop',
-    NOTES => 'Adobe Photoshop schema tags.',
+    NOTES => 'Adobe Photoshop namespace tags.',
     AuthorsPosition => { Groups => { 2 => 'Author' } },
     CaptionWriter   => { Groups => { 2 => 'Author' } },
@@ -882,12 +1136,14 @@
     DateCreated     => { Groups => { 2 => 'Time' }, %dateTimeInfo },
     DocumentAncestors => {
-        List => 'bag',
-        Struct => {
-            STRUCT_NAME => 'Ancestor',
-            NAMESPACE   => 'photoshop',
-            AncestorID => { },
-        },
-    },
-    DocumentAncestorsAncestorID => { Name => 'DocumentAncestorID', Flat => 1 },
+        List => 'Bag',
+        # Contrary to their own XMP specification, Adobe writes this as a simple Bag
+        # of strings instead of structures, so comment out the structure definition...
+        # FlatName => 'Document',
+        # Struct => {
+        #     STRUCT_NAME => 'Ancestor',
+        #     NAMESPACE   => 'photoshop',
+        #     AncestorID  => { },
+        # },
+    },
     Headline        => { },
     History         => { }, #PH (CS3)
@@ -904,15 +1160,14 @@
     SupplementalCategories  => { List => 'Bag' },
     TextLayers => {
-        List => 'seq',
+        FlatName => 'Text',
+        List => 'Seq',
         Struct => {
             STRUCT_NAME => 'Layer',
             NAMESPACE   => 'photoshop',
-            LayerName => { },
+            LayerName   => { },
             LayerText => { },
         },
     },
-    TextLayersLayerName => { Flat => 1, Name => 'TextLayerName' },
-    TextLayersLayerText => { Flat => 1, Name => 'TextLayerText' },
-    TransmissionReference   => { },
+    TransmissionReference => { Notes => 'Now used as a job identifier' },
     Urgency         => {
         Writable => 'integer',
@@ -931,13 +1186,17 @@
         },
     },
-);
-
-# Photoshop Camera Raw Schema properties (crs) - (ref 8,PH)
+    EmbeddedXMPDigest => { },   #PH (LR5)
+);
+
+# Photoshop Camera Raw namespace properties (crs) - (ref 8,PH)
 %Image::ExifTool::XMP::crs = (
     %xmpTableDefaults,
     GROUPS => { 1 => 'XMP-crs', 2 => 'Image' },
     NAMESPACE   => 'crs',
-    TABLE_DESC => 'Photoshop Camera Raw Schema',
-    NOTES => 'Photoshop Camera Raw Schema tags.',
+    TABLE_DESC => 'Photoshop Camera Raw namespace',
+    NOTES => q{
+        Photoshop Camera Raw namespace tags.  It is a shame that Adobe pollutes the
+        metadata space with these incredibly bulky image editing parameters.
+    },
     AlreadyApplied  => { Writable => 'boolean' }, #PH (written by LightRoom beta 4.1)
     AutoBrightness  => { Writable => 'boolean' },
@@ -984,5 +1243,5 @@
     Sharpness       => { Writable => 'integer', Avoid => 1 },
     Smoothness      => { Writable => 'integer' },
-    Temperature     => { Writable => 'integer', Avoid => 1, Name => 'ColorTemperature' },
+    Temperature     => { Writable => 'integer', Name => 'ColorTemperature' },
     Tint            => { Writable => 'integer' },
     ToneCurve       => { List => 'Seq' },
@@ -1055,9 +1314,9 @@
     SharpenEdgeMasking          => { Writable => 'integer' },
     SharpenRadius               => { Writable => 'real' },
-    SplitToningBalance          => { Writable => 'integer' },
-    SplitToningHighlightHue     => { Writable => 'integer' },
-    SplitToningHighlightSaturation => { Writable => 'integer' },
-    SplitToningShadowHue        => { Writable => 'integer' },
-    SplitToningShadowSaturation => { Writable => 'integer' },
+    SplitToningBalance          => { Writable => 'integer', Notes => 'also used for newer ColorGrade settings' },
+    SplitToningHighlightHue     => { Writable => 'integer', Notes => 'also used for newer ColorGrade settings' },
+    SplitToningHighlightSaturation => { Writable => 'integer', Notes => 'also used for newer ColorGrade settings' },
+    SplitToningShadowHue        => { Writable => 'integer', Notes => 'also used for newer ColorGrade settings' },
+    SplitToningShadowSaturation => { Writable => 'integer', Notes => 'also used for newer ColorGrade settings' },
     Vibrance                    => { Writable => 'integer' },
     # new tags written by LR 1.4 (not sure in what version they first appeared)
@@ -1090,72 +1349,13 @@
     # because these are nested in lists and the flattened tags can't
     # do justice to this complex structure
-    GradientBasedCorrections => { Struct => \%sCorrection, List => 'Seq' },
-    GradientBasedCorrectionsWhat => {
-        Name => 'GradientBasedCorrWhat',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionAmount => {
-        Name => 'GradientBasedCorrAmount',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionActive => {
-        Name => 'GradientBasedCorrActive',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalExposure => {
-        Name => 'GradientBasedCorrExposure',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalSaturation => {
-        Name => 'GradientBasedCorrSaturation',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalContrast => {
-        Name => 'GradientBasedCorrContrast',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalClarity => {
-        Name => 'GradientBasedCorrClarity',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalSharpness => {
-        Name => 'GradientBasedCorrSharpness',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalBrightness => {
-        Name => 'GradientBasedCorrBrightness',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalToningHue => {
-        Name => 'GradientBasedCorrHue',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsLocalToningSaturation => {
-        Name => 'GradientBasedCorrSaturation',
-        Flat => 1, List => 0,
+    GradientBasedCorrections => {
+        FlatName => 'GradientBasedCorr',
+        Struct => \%sCorrection,
+        List => 'Seq',
     },
     GradientBasedCorrectionsCorrectionMasks => {
         Name => 'GradientBasedCorrMasks',
+        FlatName => 'GradientBasedCorrMask',
         Flat => 1
-    },
-    GradientBasedCorrectionsCorrectionMasksWhat => {
-        Name => 'GradientBasedCorrMaskWhat',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksMaskValue => {
-        Name => 'GradientBasedCorrMaskValue',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksRadius => {
-        Name => 'GradientBasedCorrMaskRadius',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksFlow => {
-        Name => 'GradientBasedCorrMaskFlow',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksCenterWeight => {
-        Name => 'GradientBasedCorrMaskCenterWeight',
-        Flat => 1, List => 0,
     },
     GradientBasedCorrectionsCorrectionMasksDabs => {
@@ -1163,88 +1363,13 @@
         Flat => 1, List => 0,
     },
-    GradientBasedCorrectionsCorrectionMasksZeroX => {
-        Name => 'GradientBasedCorrMaskZeroX',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksZeroY => {
-        Name => 'GradientBasedCorrMaskZeroY',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksFullX => {
-        Name => 'GradientBasedCorrMaskFullX',
-        Flat => 1, List => 0,
-    },
-    GradientBasedCorrectionsCorrectionMasksFullY => {
-        Name => 'GradientBasedCorrMaskFullY',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrections => { Struct => \%sCorrection, List => 'Seq' },
-    PaintBasedCorrectionsWhat => {
-        Name => 'PaintCorrectionWhat',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionAmount => {
-        Name => 'PaintCorrectionAmount',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionActive => {
-        Name => 'PaintCorrectionActive',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalExposure => {
-        Name => 'PaintCorrectionExposure',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalSaturation => {
-        Name => 'PaintCorrectionSaturation',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalContrast => {
-        Name => 'PaintCorrectionContrast',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalClarity => {
-        Name => 'PaintCorrectionClarity',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalSharpness => {
-        Name => 'PaintCorrectionSharpness',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalBrightness => {
-        Name => 'PaintCorrectionBrightness',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalToningHue => {
-        Name => 'PaintCorrectionHue',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsLocalToningSaturation => {
-        Name => 'PaintCorrectionSaturation',
-        Flat => 1, List => 0,
+    PaintBasedCorrections => {
+        FlatName => 'PaintCorrection',
+        Struct => \%sCorrection,
+        List => 'Seq',
     },
     PaintBasedCorrectionsCorrectionMasks => {
         Name => 'PaintBasedCorrectionMasks',
+        FlatName => 'PaintCorrectionMask',
         Flat => 1,
-    },
-    PaintBasedCorrectionsCorrectionMasksWhat => {
-        Name => 'PaintCorrectionMaskWhat',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionMasksMaskValue => {
-        Name => 'PaintCorrectionMaskValue',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionMasksRadius => {
-        Name => 'PaintCorrectionMaskRadius',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionMasksFlow => {
-        Name => 'PaintCorrectionMaskFlow',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionMasksCenterWeight => {
-        Name => 'PaintCorrectionMaskCenterWeight',
-        Flat => 1, List => 0,
     },
     PaintBasedCorrectionsCorrectionMasksDabs => {
@@ -1252,45 +1377,202 @@
         Flat => 1, List => 0,
     },
-    PaintBasedCorrectionsCorrectionMasksZeroX => {
-        Name => 'PaintCorrectionMaskZeroX',
+    # new tags written by LR 3 (thanks Wolfgang Guelcker)
+    ProcessVersion                      => { },
+    LensProfileEnable                   => { Writable => 'integer' },
+    LensProfileSetup                    => { },
+    LensProfileName                     => { },
+    LensProfileFilename                 => { },
+    LensProfileDigest                   => { },
+    LensProfileDistortionScale          => { Writable => 'integer' },
+    LensProfileChromaticAberrationScale => { Writable => 'integer' },
+    LensProfileVignettingScale          => { Writable => 'integer' },
+    LensManualDistortionAmount          => { Writable => 'integer' },
+    PerspectiveVertical                 => { Writable => 'integer' },
+    PerspectiveHorizontal               => { Writable => 'integer' },
+    PerspectiveRotate                   => { Writable => 'real'    },
+    PerspectiveScale                    => { Writable => 'integer' },
+    CropConstrainToWarp                 => { Writable => 'integer' },
+    LuminanceNoiseReductionDetail       => { Writable => 'integer' },
+    LuminanceNoiseReductionContrast     => { Writable => 'integer' },
+    ColorNoiseReductionDetail           => { Writable => 'integer' },
+    GrainAmount                         => { Writable => 'integer' },
+    GrainSize                           => { Writable => 'integer' },
+    GrainFrequency                      => { Writable => 'integer' },
+    # new tags written by LR4
+    AutoLateralCA                       => { Writable => 'integer' },
+    Exposure2012                        => { Writable => 'real' },
+    Contrast2012                        => { Writable => 'integer' },
+    Highlights2012                      => { Writable => 'integer' },
+    Highlight2012                       => { Writable => 'integer' }, # (written by Nikon software)
+    Shadows2012                         => { Writable => 'integer' },
+    Whites2012                          => { Writable => 'integer' },
+    Blacks2012                          => { Writable => 'integer' },
+    Clarity2012                         => { Writable => 'integer' },
+    PostCropVignetteHighlightContrast   => { Writable => 'integer' },
+    ToneCurveName2012                   => { },
+    ToneCurveRed                        => { List => 'Seq' },
+    ToneCurveGreen                      => { List => 'Seq' },
+    ToneCurveBlue                       => { List => 'Seq' },
+    ToneCurvePV2012                     => { List => 'Seq' },
+    ToneCurvePV2012Red                  => { List => 'Seq' },
+    ToneCurvePV2012Green                => { List => 'Seq' },
+    ToneCurvePV2012Blue                 => { List => 'Seq' },
+    DefringePurpleAmount                => { Writable => 'integer' },
+    DefringePurpleHueLo                 => { Writable => 'integer' },
+    DefringePurpleHueHi                 => { Writable => 'integer' },
+    DefringeGreenAmount                 => { Writable => 'integer' },
+    DefringeGreenHueLo                  => { Writable => 'integer' },
+    DefringeGreenHueHi                  => { Writable => 'integer' },
+    # new tags written by LR5
+    AutoWhiteVersion                    => { Writable => 'integer' },
+    CircularGradientBasedCorrections => {
+        FlatName => 'CircGradBasedCorr',
+        Struct => \%sCorrection,
+        List => 'Seq',
+    },
+    CircularGradientBasedCorrectionsCorrectionMasks => {
+        Name => 'CircGradBasedCorrMasks',
+        FlatName => 'CircGradBasedCorrMask',
+        Flat => 1
+    },
+    CircularGradientBasedCorrectionsCorrectionMasksDabs => {
+        Name => 'CircGradBasedCorrMaskDabs',
         Flat => 1, List => 0,
     },
-    PaintBasedCorrectionsCorrectionMasksZeroY => {
-        Name => 'PaintCorrectionMaskZeroY',
+    ColorNoiseReductionSmoothness       => { Writable => 'integer' },
+    PerspectiveAspect                   => { Writable => 'integer' },
+    PerspectiveUpright                  => { Writable => 'integer' },
+    RetouchAreas => {
+        FlatName => 'RetouchArea',
+        Struct => \%sRetouchArea,
+        List => 'Seq',
+    },
+    RetouchAreasMasks => {
+        Name => 'RetouchAreaMasks',
+        FlatName => 'RetouchAreaMask',
+        Flat => 1
+    },
+    RetouchAreasMasksDabs => {
+        Name => 'RetouchAreaMaskDabs',
         Flat => 1, List => 0,
     },
-    PaintBasedCorrectionsCorrectionMasksFullX => {
-        Name => 'PaintCorrectionMaskFullX',
-        Flat => 1, List => 0,
-    },
-    PaintBasedCorrectionsCorrectionMasksFullY => {
-        Name => 'PaintCorrectionMaskFullY',
-        Flat => 1, List => 0,
-    },
-    # new tags written by LR 3 (thanks Wolfgang Guelcker)
-    ProcessVersion                       => { },
-    LensProfileEnable                    => { Writable => 'integer' },
-    LensProfileSetup                     => { },
-    LensProfileName                      => { },
-    LensProfileFilename                  => { },
-    LensProfileDigest                    => { },
-    LensProfileDistortionScale           => { Writable => 'integer' },
-    LensProfileChromaticAberrationScale  => { Writable => 'integer' },
-    LensProfileVignettingScale           => { Writable => 'integer' },
-    LensManualDistortionAmount           => { Writable => 'integer' },
-    PerspectiveVertical                  => { Writable => 'integer' },
-    PerspectiveHorizontal                => { Writable => 'integer' },
-    PerspectiveRotate                    => { Writable => 'real'    },
-    PerspectiveScale                     => { Writable => 'integer' },
-    CropConstrainToWarp                  => { Writable => 'integer' },      
-    LuminanceNoiseReductionDetail        => { Writable => 'integer' },
-    LuminanceNoiseReductionContrast      => { Writable => 'integer' },
-    ColorNoiseReductionDetail            => { Writable => 'integer' },
-    GrainAmount                          => { Writable => 'integer' },
-    GrainSize                            => { Writable => 'integer' },
-    GrainFrequency                       => { Writable => 'integer' },
-);
-
-# Tiff schema properties (tiff)
+    UprightVersion                      => { Writable => 'integer' },
+    UprightCenterMode                   => { Writable => 'integer' },
+    UprightCenterNormX                  => { Writable => 'real' },
+    UprightCenterNormY                  => { Writable => 'real' },
+    UprightFocalMode                    => { Writable => 'integer' },
+    UprightFocalLength35mm              => { Writable => 'real' },
+    UprightPreview                      => { Writable => 'boolean' },
+    UprightTransformCount               => { Writable => 'integer' },
+    UprightDependentDigest              => { },
+    UprightTransform_0                  => { },
+    UprightTransform_1                  => { },
+    UprightTransform_2                  => { },
+    UprightTransform_3                  => { },
+    UprightTransform_4                  => { },
+    UprightTransform_5                  => { },
+    # more stuff seen in lens profile file (unknown source)
+    What => { }, # (with value "LensProfileDefaultSettings")
+    LensProfileMatchKeyExifMake         => { },
+    LensProfileMatchKeyExifModel        => { },
+    LensProfileMatchKeyCameraModelName  => { },
+    LensProfileMatchKeyLensInfo         => { },
+    LensProfileMatchKeyLensID           => { },
+    LensProfileMatchKeyLensName         => { },
+    LensProfileMatchKeyIsRaw            => { Writable => 'boolean' },
+    LensProfileMatchKeySensorFormatFactor=>{ Writable => 'real' },
+    # more stuff (ref forum6993)
+    DefaultAutoTone                     => { Writable => 'boolean' },
+    DefaultAutoGray                     => { Writable => 'boolean' },
+    DefaultsSpecificToSerial            => { Writable => 'boolean' },
+    DefaultsSpecificToISO               => { Writable => 'boolean' },
+    DNGIgnoreSidecars                   => { Writable => 'boolean' },
+    NegativeCachePath                   => { },
+    NegativeCacheMaximumSize            => { Writable => 'real' },
+    NegativeCacheLargePreviewSize       => { Writable => 'integer' },
+    JPEGHandling                        => { },
+    TIFFHandling                        => { },
+    Dehaze                              => { Writable => 'real' },
+    ToneMapStrength                     => { Writable => 'real' },
+    # yet more
+    PerspectiveX                        => { Writable => 'real' },
+    PerspectiveY                        => { Writable => 'real' },
+    UprightFourSegmentsCount            => { Writable => 'integer' },
+    AutoTone                            => { Writable => 'boolean' },
+    Texture                             => { Writable => 'integer' },
+    # more stuff (ref forum10721)
+    OverrideLookVignette                => { Writable => 'boolean' },
+    Look => {
+        Struct => {
+            STRUCT_NAME => 'Look',
+            NAMESPACE   => 'crs',
+            Name        => { },
+            Amount      => { },
+            Cluster     => { },
+            UUID        => { },
+            SupportsMonochrome => { },
+            SupportsAmount     => { },
+            SupportsOutputReferred => { },
+            Copyright   => { },
+            Group       => { Writable => 'lang-alt' },
+            Parameters => {
+                Struct => {
+                    STRUCT_NAME => 'LookParms',
+                    NAMESPACE   => 'crs',
+                    Version         => { },
+                    ProcessVersion  => { },
+                    Clarity2012     => { },
+                    ConvertToGrayscale => { },
+                    CameraProfile   => { },
+                    LookTable       => { },
+                    ToneCurvePV2012 => { List => 'Seq' },
+                },
+            },
+        }
+    },
+    # more again (ref forum11258)
+    GrainSeed => { },
+    ClipboardOrientation => { Writable => 'integer' },
+    ClipboardAspectRatio => { Writable => 'integer' },
+    PresetType  => { },
+    Cluster     => { },
+    UUID        => { Avoid => 1 },
+    SupportsAmount          => { Writable => 'boolean' },
+    SupportsColor           => { Writable => 'boolean' },
+    SupportsMonochrome      => { Writable => 'boolean' },
+    SupportsHighDynamicRange=> { Writable => 'boolean' },
+    SupportsNormalDynamicRange=> { Writable => 'boolean' },
+    SupportsSceneReferred   => { Writable => 'boolean' },
+    SupportsOutputReferred  => { Writable => 'boolean' },
+    CameraModelRestriction  => { },
+    Copyright   => { Avoid => 1 },
+    ContactInfo => { },
+    GrainSeed   => { Writable => 'integer' },
+    Name        => { Writable => 'lang-alt', Avoid => 1 },
+    ShortName   => { Writable => 'lang-alt' },
+    SortName    => { Writable => 'lang-alt' },
+    Group       => { Writable => 'lang-alt', Avoid => 1 },
+    Description => { Writable => 'lang-alt', Avoid => 1 },
+    # new for DNG converter 13.0
+    LookName => { NotFlat => 1 }, # (grr... conflicts with "Name" element of "Look" struct!)
+    # new for Lightroom CC 2021 (ref forum11745)
+    ColorGradeMidtoneHue    => { Writable => 'integer' },
+    ColorGradeMidtoneSat    => { Writable => 'integer' },
+    ColorGradeShadowLum     => { Writable => 'integer' },
+    ColorGradeMidtoneLum    => { Writable => 'integer' },
+    ColorGradeHighlightLum  => { Writable => 'integer' },
+    ColorGradeBlending      => { Writable => 'integer' },
+    ColorGradeGlobalHue     => { Writable => 'integer' },
+    ColorGradeGlobalSat     => { Writable => 'integer' },
+    ColorGradeGlobalLum     => { Writable => 'integer' },
+    # new for Adobe Camera Raw 13 (ref forum11745)
+    LensProfileIsEmbedded   => { Writable => 'boolean'},
+    AutoToneDigest          => { },
+    AutoToneDigestNoSat     => { },
+    ToggleStyleDigest       => { },
+    ToggleStyleAmount       => { Writable => 'integer' },
+);
+
+# Tiff namespace properties (tiff)
 %Image::ExifTool::XMP::tiff = (
     %xmpTableDefaults,
@@ -1299,5 +1581,9 @@
     PRIORITY => 0, # not as reliable as actual TIFF tags
     TABLE_DESC => 'XMP TIFF',
-    NOTES => 'EXIF schema for TIFF tags.',
+    NOTES => q{
+        EXIF namespace for TIFF tags.  See
+        L<https://web.archive.org/web/20180921145139if_/http://www.cipa.jp:80/std/documents/e/DC-010-2017_E.pdf>
+        for the specification.
+    },
     ImageWidth    => { Writable => 'integer' },
     ImageLength   => { Writable => 'integer', Name => 'ImageHeight' },
@@ -1324,5 +1610,16 @@
         },
     },
-    YCbCrSubSampling => { PrintConv => \%Image::ExifTool::JPEG::yCbCrSubSampling },
+    YCbCrSubSampling => {
+        Writable => 'integer',
+        List => 'Seq',
+        # join the raw values before conversion to allow PrintConv to operate on
+        # the combined string as it does for the corresponding EXIF tag
+        RawJoin => 1,
+        Notes => q{
+            while technically this is a list-type tag, for compatibility with its EXIF
+            counterpart it is written and read as a simple string
+        },
+        PrintConv => \%Image::ExifTool::JPEG::yCbCrSubSampling,
+    },
     YCbCrPositioning => {
         Writable => 'integer',
@@ -1343,5 +1640,5 @@
         },
     },
-    TransferFunction      => { Writable => 'integer',  List => 'Seq' },
+    TransferFunction      => { Writable => 'integer',  List => 'Seq', AutoSplit => 1 },
     WhitePoint            => { Writable => 'rational', List => 'Seq', AutoSplit => 1 },
     PrimaryChromaticities => { Writable => 'rational', List => 'Seq', AutoSplit => 1 },
@@ -1354,6 +1651,13 @@
     },
     ImageDescription => { Writable => 'lang-alt' },
-    Make      => { Groups => { 2 => 'Camera' } },
-    Model     => { Groups => { 2 => 'Camera' }, Description => 'Camera Model Name' },
+    Make => {
+        Groups => { 2 => 'Camera' },
+        RawConv => '$$self{Make} ? $val : $$self{Make} = $val',
+    },
+    Model => {
+        Groups => { 2 => 'Camera' },
+        Description => 'Camera Model Name',
+        RawConv => '$$self{Model} ? $val : $$self{Model} = $val',
+    },
     Software  => { },
     Artist    => { Groups => { 2 => 'Author' } },
@@ -1362,5 +1666,5 @@
 );
 
-# Exif schema properties (exif)
+# Exif namespace properties (exif)
 %Image::ExifTool::XMP::exif = (
     %xmpTableDefaults,
@@ -1368,5 +1672,9 @@
     NAMESPACE   => 'exif',
     PRIORITY => 0, # not as reliable as actual EXIF tags
-    NOTES => 'EXIF schema for EXIF tags.',
+    NOTES => q{
+        EXIF namespace for EXIF tags.  See
+        L<https://web.archive.org/web/20180921145139if_/http://www.cipa.jp:80/std/documents/e/DC-010-2017_E.pdf>
+        for the specification.
+    },
     ExifVersion     => { },
     FlashpixVersion => { },
@@ -1383,6 +1691,6 @@
     },
     ComponentsConfiguration => {
+        Writable => 'integer',
         List => 'Seq',
-        Writable => 'integer',
         AutoSplit => 1,
         PrintConvColumns => 2,
@@ -1416,9 +1724,9 @@
         Writable => 'rational',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
-        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+        PrintConvInv => '$val',
     },
     FNumber => {
         Writable => 'rational',
-        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
         PrintConvInv => '$val',
     },
@@ -1447,11 +1755,8 @@
     OECF => {
         Name => 'Opto-ElectricConvFactor',
+        FlatName => 'OECF',
         Groups => { 2 => 'Camera' },
         Struct => \%sOECF,
     },
-    OECFColumns => { Flat => 1 },
-    OECFRows    => { Flat => 1 },
-    OECFNames   => { Flat => 1 },
-    OECFValues  => { Flat => 1 },
     ShutterSpeedValue => {
         Writable => 'rational',
@@ -1512,5 +1817,5 @@
             STRUCT_NAME => 'Flash',
             NAMESPACE   => 'exif',
-            Fired       => { Writable => 'boolean' },
+            Fired       => { Writable => 'boolean', %boolConv },
             Return => {
                 Writable => 'integer',
@@ -1530,6 +1835,6 @@
                 },
             },
-            Function    => { Writable => 'boolean' },
-            RedEyeMode  => { Writable => 'boolean' },
+            Function    => { Writable => 'boolean', %boolConv },
+            RedEyeMode  => { Writable => 'boolean', %boolConv },
         },
     },
@@ -1713,5 +2018,4 @@
         Groups => { 2 => 'Location' },
         Writable => 'rational',
-        RawConv => 'require Image::ExifTool::GPS; $val', # to load Composite tags and routines
         # extricate unsigned decimal number from string
         ValueConvInv => '$val=~/((?=\d|\.\d)\d*(?:\.\d*)?)/ ? $1 : undef',
@@ -1766,4 +2070,5 @@
     GPSTrack => { Groups => { 2 => 'Location' }, Writable => 'rational' },
     GPSImgDirectionRef => {
+        Groups => { 2 => 'Location' },
         PrintConv => {
             M => 'Magnetic North',
